commit 1aef951f1aa0b50a8da12f6fe6e80f3fdaa4d98e
Author: Patrick Palka <ppalka@redhat.com>
Date:   Tue Oct 5 21:35:21 2021

    c++: unifying equal NONTYPE_ARGUMENT_PACKs [PR102547]
    
    Here during partial ordering of the two partial specializations we end
    up in unify with parm=arg=NONTYPE_ARGUMENT_PACK<V0, V1>, and crash shortly
    thereafter because uses_template_parms(parms) calls potential_const_expr
    which doesn't handle NONTYPE_ARGUMENT_PACK.
    
    This patch fixes this by extending potential_constant_expression to handle
    NONTYPE_ARGUMENT_PACK appropriately.
    
            PR c++/102547
    
    gcc/cp/ChangeLog:
    
            * constexpr.c (potential_constant_expression_1): Handle
            NONTYPE_ARGUMENT_PACK.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/cpp0x/variadic-partial2.C: New test.
            * g++.dg/cpp0x/variadic-partial2a.C: New test.
    
    (cherry picked from commit d4c470c376b4cb82c9a0b7e8a4b88c44d5e4289d)

diff --git a/gcc/cp/constexpr.c b/gcc/cp/constexpr.c
index 31facd274e9..3da7a246167 100644
--- a/gcc/cp/constexpr.c
+++ b/gcc/cp/constexpr.c
@@ -8940,6 +8940,16 @@ potential_constant_expression_1 (tree t, bool want_rval, bool strict, bool now,
     case CO_RETURN_EXPR:
       return false;
 
+    case NONTYPE_ARGUMENT_PACK:
+      {
+	tree args = ARGUMENT_PACK_ARGS (t);
+	int len = TREE_VEC_LENGTH (args);
+	for (int i = 0; i < len; ++i)
+	  if (!RECUR (TREE_VEC_ELT (args, i), any))
+	    return false;
+	return true;
+      }
+
     default:
       if (objc_non_constant_expr_p (t))
 	return false;
diff --git a/gcc/testsuite/g++.dg/cpp0x/variadic-partial2.C b/gcc/testsuite/g++.dg/cpp0x/variadic-partial2.C
new file mode 100644
index 00000000000..df61f26a3c1
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp0x/variadic-partial2.C
@@ -0,0 +1,16 @@
+// PR c++/102547
+// { dg-do compile { target c++11 } }
+
+template<int... Vs>
+struct vals { };
+
+template<class V, class T>
+struct vals_client { };
+
+template<int V0, int V1, class T>
+struct vals_client<vals<V0, V1>, T> { };
+
+template<int V0, int V1>
+struct vals_client<vals<V0, V1>, void> { };
+
+template struct vals_client<vals<1, 2>, void>; //- "sorry, unimplemented..., ICE"
diff --git a/gcc/testsuite/g++.dg/cpp0x/variadic-partial2a.C b/gcc/testsuite/g++.dg/cpp0x/variadic-partial2a.C
new file mode 100644
index 00000000000..e98bdbbc07b
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp0x/variadic-partial2a.C
@@ -0,0 +1,22 @@
+// PR c++/102547
+// { dg-do compile { target c++11 } }
+// A version of variadic-partial2.C where partial ordering is performed
+// on function templates instead of class templates.
+
+template<int... Vs>
+struct vals { };
+
+template<class V, class T>
+void f(V, T) { };
+
+template<int V0, int V1, class T>
+void f(vals<V0, V1>, T) { };
+
+template<int V0, int V1>
+void f(vals<V0, V1>, char) { };
+
+template void f(vals<1, 2>, char); //- "sorry, unimplemented..., ICE"
+
+int main() {
+  f(vals<1, 3>{}, 'a'); //- "sorry, unimplemented..., ICE"
+}

